=== debian/changelog ===
condor (23.2.0+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Source-only upload.

 -- Andreas Tille <tille@debian.org>  Fri, 05 Jan 2024 20:47:23 +0100

condor (23.2.0+dfsg-1) unstable; urgency=medium

  [ Tim Theisen ]
  * Add backward compatible overrides for old lintian used by ftp-masters
  * new upstream feature release (Closes: #982050, #995838, #1020692)
  * Fixes for CVE-2019-18823 (Closes: #963777)
  * Fixes for CVE-2021-25311
  * Fixes for CVE-2021-25312
  * Fixes for CVE-2021-45101 (Closes: #1002540)
  * Fixes for CVE-2021-45102
  * Fixes for CVE-2021-45103
  * Fixes for CVE-2021-45104
  * Fixes for CVE-2022-26110 (Closes: #1008634)
  * Builds with GCC 12 (Closes: #925657)
  * Python bindings for Python 3 (Closes: #790545, #936323, #966726)
  * Port to libpcre2 (Closes: #1000130)
  * Remove globus support (upstream change) (Closes: #671467)
  * add minihtcondor package
  * add htcondor-annex-ec2 package
  * restore openstack_gahp sources
  * Squash lintian errors and warnings
  * Too many to mention see online documentation:
    - https://htcondor.readthedocs.io/en/23.x/version-history/index.html

  [ Alex Waite ]
  * new upstream stable release (update to latest 8.8 stable series)
    - new tool: 'condor_now' - run a job right now by swapping it with another
      specified running job.
    - now tracks and reports GPU Usage and GPU memory usage
    - new grid type 'azure'
    - support for user and daemon authentication using the MUNGE service
    - fixed a memory leak in SSL authentication
    - Reduced encrypted file transfer CPU usage by a factor of six
    - HTCondor can now recognize nVidia Volta and Turing GPUs
  * drop numerous patches (thanks to Tim Theisen's upstreaming efforts!)
  * retire init.d scripts
  * fix assorted lintian errors

  [ Andreas Tille ]
  * cme fix dpkg-control:
     - Point Vcs-fields to Salsa
     - Priotity: optional
     - Drop unneeded versions from dependencies
  * Fix watch file
  * Maintain Files-Excluded
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/control (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Trim trailing whitespace.
  * Transition to automatic debug package (from: htcondor-dbg).
  * Use secure URI in Homepage field.
  * Apply multi-arch hints.
    + htcondor-doc: Add Multi-Arch: foreign.
  * Fix clean target
  * Add missing build dependency on dh addon.
  * Build-Depends: libscitokens-dev, libsqlite3-dev, libglobus-gss-assist-dev
  * Build-Depends: python3-sphinx-autodoc-typehints, python3-nbsphinx
  * Standards-Version: 4.6.1 (routine-update)
  * Fix some issues via `cme fix dpkg-control`
  * Fix VCS fields
  * Build-Depends: rapidjson-dev
  * Enable hardening options
  * Drop windows binaries from upstream source
  * Avoid privacy breach by bootstrap and jquery links
  * Set upstream metadata fields: Repository-Browse.
  * Remove field Section on binary packages htcondor-annex-ec2, minihtcondor
    that duplicates source.
  * Enforce bash as interpreter if bash syntax is used
  * Enable binNMUs
  * Drop unneeded debian/htcondor.conffiles
  * Lintian-overrides
  * Team maintenance by Debian HPC Team <debian-hpc@lists.debian.org>
  * Remove /etc/rc.d/init.d/glite-ce-blah-parser from htcondor package
  * https in watch file
  * Remove manual creation of trigger
  * Move bash_completion to correct dir
  * Remove debian/htcondor.templates
  * watch file reports only even numbered minor versions

 -- Tim Theisen <tim@cs.wisc.edu>  Wed, 27 Dec 2023 20:30:00 -0600
